SystemOrganization addCategory: #ConfigurationOfEphestos!

Object subclass: #ConfigurationOfEphestos
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfEphestos'!

!ConfigurationOfEphestos class methodsFor: 'development support' stamp: 'kilonAlios 9/20/2014 20:04'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfEphestos class methodsFor: 'private' stamp: 'kilonAlios 9/20/2014 20:04'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfEphestos class methodsFor: 'private' stamp: 'kilonAlios 9/20/2014 20:04'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfEphestos class methodsFor: 'private' stamp: 'kilonAlios 9/20/2014 20:04'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfEphestos class methodsFor: 'metacello tool support' stamp: 'kilonAlios 9/20/2014 20:04'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfEphestos class methodsFor: 'loading' stamp: 'kilonAlios 9/20/2014 20:04'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfEphestos class methodsFor: 'loading' stamp: 'kilonAlios 9/20/2014 20:04'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfEphestos class methodsFor: 'loading' stamp: 'kilonAlios 9/20/2014 20:04'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfEphestos class methodsFor: 'accessing' stamp: 'kilonAlios 9/20/2014 20:04'!
project

	^self new project! !

!ConfigurationOfEphestos class methodsFor: 'development support' stamp: 'kilonAlios 9/20/2014 20:04'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfEphestos methodsFor: 'baselines' stamp: 'kilonAlios 9/20/2014 20:04'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'. ].
! !

!ConfigurationOfEphestos methodsFor: 'baselines' stamp: 'kilonAlios 9/20/2014 20:07'!
baseline02: spec
	<version: '0.2-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/kilon/Ephestos/main/'.
		spec package: 'Ephestos'. ].
! !

!ConfigurationOfEphestos methodsFor: 'accessing' stamp: 'kilonAlios 9/20/2014 20:04'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfEphestos methodsFor: 'symbolic versions' stamp: 'kilonAlios 9/20/2014 20:07'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.2-baseline'.
! !

!ConfigurationOfEphestos methodsFor: 'accessing' stamp: 'kilonAlios 9/20/2014 20:04'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfEphestos methodsFor: 'symbolic versions' stamp: 'kilonAlios 9/20/2014 20:07'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '0.1'.
! !

!ConfigurationOfEphestos methodsFor: 'versions' stamp: 'kilonAlios 9/20/2014 20:15'!
version01: spec
	<version: '0.1' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.1
This is 0.1 the first stable release of Ephestos. This release contains the following

-a socket client bridge for sending and receiving messages from Blender which acts as a socket server

- a sendMessage: message to send python command as string to Blender to be executed

- a python parser that allows the pharo syntax to be used to parse to a python command for simple things like calling instance and class method and assigning class and instance variables

- a getValue: message for reading python values from variables

- support for triggering the pharo dedugger on python error

- support for sending multiple lines of python code in a single message'.
		spec author: 'kilonAlios'.
		spec timestamp: '9/20/2014 20:15'.
		spec package: 'Ephestos' with: 'Ephestos-kilonAlios.16'. ].
! !
